? invert-proc.patch
? src/data/procedure.c.1
Index: src/data/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/ChangeLog,v
retrieving revision 1.91
diff -u -p -r1.91 ChangeLog
--- src/data/ChangeLog	16 Dec 2006 22:11:08 -0000	1.91
+++ src/data/ChangeLog	17 Dec 2006 06:28:23 -0000
@@ -1,3 +1,37 @@
+Sat Dec 16 22:05:18 2006  Ben Pfaff  <blp@gnu.org>
+
+	Make it possible to pull cases from the active file with a
+	function call, instead of requiring indirection through a callback
+	function.
+
+	* case-source.h (struct case_source_class): Change ->read function
+	to return a single case, instead of calling a callback function
+	for each case.  Change ->destroy function to return an error
+	status.
+
+	* case-source.c (free_case_source): Pass along the value returned
+	by the case_source ->destroy function.
+
+	* procedure.c (struct write_case_data): Removed.
+	(struct dataset): Added some members to track procedure state.
+	(procedure): Optimize the trivial case at this level.
+	(internal_procedure): Re-implement in terms of proc_open,
+	proc_read, proc_close.
+	(proc_open) New function.
+	(proc_read) New function.
+	(proc_close) New function.
+	(write_case) Moved into proc_read.
+	(close_active_file) Moved closing of data source into proc_close.
+
+	* storage-source.c: Rewrote to conform with modified
+	case_source_class interface.
+
+	* transformations.c (trns_chain_execute): Added argument to allow
+	starting execution from an arbitrary transformation.  Updated
+	callers.
+
+	* transformations.h (enum TRNS_NEXT_CASE) Renamed TRNS_END_CASE.
+
 Sat Dec 16 14:09:25 2006  Ben Pfaff  <blp@gnu.org>
 
 	* sys-file-reader.c (read_display_parameters): Don't assume that
Index: src/data/case-source.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/case-source.c,v
retrieving revision 1.3
diff -u -p -r1.3 case-source.c
--- src/data/case-source.c	15 Dec 2006 00:16:01 -0000	1.3
+++ src/data/case-source.c	17 Dec 2006 06:28:23 -0000
@@ -36,17 +36,21 @@ create_case_source (const struct case_so
   return source;
 }
 
-/* Destroys case source SOURCE.  It is the caller's responsible to
-   call the source's destroy function, if any. */
-void
+/* Destroys case source SOURCE.
+   Returns true if successful,
+   false if the source encountered an I/O error during
+   destruction or reading cases. */
+bool
 free_case_source (struct case_source *source) 
 {
+  bool ok = true;
   if (source != NULL) 
     {
       if (source->class->destroy != NULL)
-        source->class->destroy (source);
+        ok = source->class->destroy (source);
       free (source);
     }
+  return ok;
 }
 
 /* Returns true if CLASS is the class of SOURCE. */
Index: src/data/case-source.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/case-source.h,v
retrieving revision 1.3
diff -u -p -r1.3 case-source.h
--- src/data/case-source.h	15 Dec 2006 00:16:01 -0000	1.3
+++ src/data/case-source.h	17 Dec 2006 06:28:23 -0000
@@ -23,9 +23,6 @@
 
 struct ccase;
 
-typedef struct write_case_data *write_case_data;
-typedef bool write_case_func (write_case_data);
-
 /* A case source. */
 struct case_source 
   {
@@ -42,21 +39,21 @@ struct case_source_class
        WRITE_CASE, if known, or -1 otherwise. */
     int (*count) (const struct case_source *);
 
-    /* Reads the cases one by one into C and for each one calls
-       WRITE_CASE passing the given AUX data.
-       Returns true if successful, false if an I/O error occurred. */
-    bool (*read) (struct case_source *,
-                  struct ccase *c,
-                  write_case_func *write_case, write_case_data aux);
-
-    /* Destroys the source. */
-    void (*destroy) (struct case_source *);
+    /* Reads one case into C.
+       Returns true if successful, false at end of file or if an
+       I/O error occurred. */
+    bool (*read) (struct case_source *, struct ccase *);
+
+    /* Destroys the source.
+       Returns true if successful read, false if an I/O occurred
+       during destruction or previously. */
+    bool (*destroy) (struct case_source *);
   };
 
 
 struct case_source *create_case_source (const struct case_source_class *,
                                         void *);
-void free_case_source (struct case_source *);
+bool free_case_source (struct case_source *);
 
 bool case_source_is_class (const struct case_source *,
                           const struct case_source_class *);
Index: src/data/procedure.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/procedure.c,v
retrieving revision 1.18
diff -u -p -r1.18 procedure.c
--- src/data/procedure.c	15 Dec 2006 00:16:02 -0000	1.18
+++ src/data/procedure.c	17 Dec 2006 06:28:24 -0000
@@ -38,20 +38,6 @@
 #include <libpspp/misc.h>
 #include <libpspp/str.h>
 
-/* Procedure execution data. */
-struct write_case_data
-  {
-    /* Function to call for each case. */
-    case_func *proc;
-    void *aux;
-
-    struct dataset *dataset;    /* The dataset concerned */
-    struct ccase trns_case;     /* Case used for transformations. */
-    struct ccase sink_case;     /* Case written to sink, if
-                                   compacting is necessary. */
-    size_t cases_written;       /* Cases output so far. */
-  };
-
 struct dataset {
   /* Cases are read from proc_source,
      pass through permanent_trns_chain (which transforms them into
@@ -84,6 +70,13 @@ struct dataset {
   int lag_head;		/* Index where next case will be added. */
   struct ccase *lag_queue; /* Array of n_lag ccase * elements. */
 
+  /* Procedure data. */
+  bool is_open;               /* Procedure open? */
+  struct ccase trns_case;     /* Case used for transformations. */
+  struct ccase sink_case;     /* Case written to sink, if
+                                 compacting is necessary. */
+  size_t cases_written;       /* Cases output so far. */
+  bool ok;
 }; /* struct dataset */
 
 
@@ -96,7 +89,6 @@ static bool internal_procedure (struct d
 static void update_last_proc_invocation (struct dataset *ds);
 static void create_trns_case (struct ccase *, struct dictionary *);
 static void open_active_file (struct dataset *ds);
-static bool write_case (struct write_case_data *wc_data);
 static void lag_case (struct dataset *ds, const struct ccase *c);
 static void clear_case (const struct dataset *ds, struct ccase *c);
 static bool close_active_file (struct dataset *ds);
@@ -134,6 +126,23 @@ time_of_last_procedure (struct dataset *
 bool
 procedure (struct dataset *ds, case_func *cf, void *aux)
 {
+  update_last_proc_invocation (ds);
+
+  /* Optimize the trivial case where we're not going to do
+     anything with the data, by not reading the data at all. */
+  if (cf == NULL
+      && case_source_is_class (ds->proc_source, &storage_source_class)
+      && ds->proc_sink == NULL
+      && (ds->temporary_trns_chain == NULL
+          || trns_chain_is_empty (ds->temporary_trns_chain))
+      && trns_chain_is_empty (ds->permanent_trns_chain))
+    {
+      ds->n_lag = 0;
+      dict_set_case_limit (ds->dict, 0);
+      dict_clear_vectors (ds->dict);
+      return true;
+    }
+
   return internal_procedure (ds, cf, NULL, aux);
 }
 
@@ -187,7 +196,6 @@ multipass_procedure (struct dataset *ds,
 
 /* Procedure implementation. */
 
-
 /* Executes a procedure.
    Passes each case to CASE_FUNC.
    Calls END_FUNC after the last case.
@@ -198,50 +206,133 @@ internal_procedure (struct dataset *ds, 
 		    end_func *end,
                     void *aux) 
 {
-  struct write_case_data wc_data;
+  struct ccase *c;
   bool ok = true;
+  
+  proc_open (ds);
+  while (ok && proc_read (ds, &c))
+    if (proc != NULL)
+      ok = proc (c, aux, ds) && ok;
+  if (end != NULL)
+    ok = end (aux, ds) && ok;
+  return proc_close (ds) && ok;
+}
 
+/* Opens dataset DS for reading cases with proc_read.
+   proc_close must be called when done. */
+void
+proc_open (struct dataset *ds)
+{
   assert (ds->proc_source != NULL);
+  assert (!ds->is_open);
 
   update_last_proc_invocation (ds);
 
-  /* Optimize the trivial case where we're not going to do
-     anything with the data, by not reading the data at all. */
-  if (proc == NULL && end == NULL
-      && case_source_is_class (ds->proc_source, &storage_source_class)
-      && ds->proc_sink == NULL
-      && (ds->temporary_trns_chain == NULL
-          || trns_chain_is_empty (ds->temporary_trns_chain))
-      && trns_chain_is_empty (ds->permanent_trns_chain))
+  open_active_file (ds);
+
+  ds->is_open = true;
+  create_trns_case (&ds->trns_case, ds->dict);
+  case_create (&ds->sink_case, dict_get_compacted_value_cnt (ds->dict));
+  ds->cases_written = 0;
+  ds->ok = true;
+}
+
+/* Reads the next case from dataset DS, which must have been
+   opened for reading with proc_open.
+   Returns true if successful, in which case a pointer to the
+   case is stored in *C.
+   Return false at end of file or if a read error occurs.  In
+   this case a null pointer is stored in *C. */
+bool
+proc_read (struct dataset *ds, struct ccase **c) 
+{
+  enum trns_result retval = TRNS_DROP_CASE;
+
+  assert (ds->is_open);
+  *c = NULL;
+  for (;;) 
+    {
+      size_t case_nr;
+
+      assert (retval == TRNS_DROP_CASE || retval == TRNS_ERROR);
+      if (retval == TRNS_ERROR)
+        ds->ok = false;
+      if (!ds->ok)
+        return false;
+
+      /* Read a case from proc_source. */
+      clear_case (ds, &ds->trns_case);
+      if (!ds->proc_source->class->read (ds->proc_source, &ds->trns_case))
+        return false;
+
+      /* Execute permanent transformations.  */
+      case_nr = ds->cases_written + 1;
+      retval = trns_chain_execute (ds->permanent_trns_chain, TRNS_CONTINUE,
+                                   &ds->trns_case, &case_nr);
+      if (retval != TRNS_CONTINUE)
+        continue;
+  
+      /* Write case to LAG queue. */
+      if (ds->n_lag)
+        lag_case (ds, &ds->trns_case);
+
+      /* Write case to replacement active file. */
+      ds->cases_written++;
+      if (ds->proc_sink->class->write != NULL) 
+        {
+          if (ds->compactor != NULL) 
+            {
+              dict_compactor_compact (ds->compactor, &ds->sink_case,
+                                      &ds->trns_case);
+              ds->proc_sink->class->write (ds->proc_sink, &ds->sink_case);
+            }
+          else
+            ds->proc_sink->class->write (ds->proc_sink, &ds->trns_case);
+        }
+  
+      /* Execute temporary transformations. */
+      if (ds->temporary_trns_chain != NULL) 
+        {
+          retval = trns_chain_execute (ds->temporary_trns_chain, TRNS_CONTINUE,
+                                       &ds->trns_case, &ds->cases_written);
+          if (retval != TRNS_CONTINUE)
+            continue;
+        }
+
+      *c = &ds->trns_case;
+      return true; 
+    }
+}
+
+/* Closes dataset DS for reading.
+   Returns true if successful, false if an I/O error occurred
+   while reading or closing the data set.
+   If DS has not been opened, returns true without doing
+   anything else. */
+bool
+proc_close (struct dataset *ds) 
+{
+  if (!ds->is_open)
+    return true;
+
+  /* Drain any remaining cases. */
+  while (ds->ok) 
     {
-      ds->n_lag = 0;
-      dict_set_case_limit (ds->dict, 0);
-      dict_clear_vectors (ds->dict);
-      return true;
+      struct ccase *c;
+      if (!proc_read (ds, &c))
+        break; 
     }
   
-  open_active_file (ds);
-  
-  wc_data.proc = proc;
-  wc_data.aux = aux;
-  wc_data.dataset = ds;
-  create_trns_case (&wc_data.trns_case, ds->dict);
-  case_create (&wc_data.sink_case,
-               dict_get_compacted_value_cnt (ds->dict));
-  wc_data.cases_written = 0;
-
-  ok = ds->proc_source->class->read (ds->proc_source,
-                                 &wc_data.trns_case,
-                                 write_case, &wc_data) && ok;
-  if (end != NULL)
-    ok = end (aux, ds) && ok;
+  ds->ok = free_case_source (ds->proc_source) && ds->ok;
+  ds->proc_source = NULL;
 
-  case_destroy (&wc_data.sink_case);
-  case_destroy (&wc_data.trns_case);
+  case_destroy (&ds->sink_case);
+  case_destroy (&ds->trns_case);
 
-  ok = close_active_file (ds) && ok;
+  ds->ok = close_active_file (ds) && ds->ok;
+  ds->is_open = false;
 
-  return ok;
+  return ds->ok;
 }
 
 /* Updates last_proc_invocation. */
@@ -314,63 +405,6 @@ open_active_file (struct dataset *ds)
     }
 }
 
-/* Transforms trns_case and writes it to the replacement active
-   file if advisable.  Returns true if more cases can be
-   accepted, false otherwise.  Do not call this function again
-   after it has returned false once.  */
-static bool
-write_case (struct write_case_data *wc_data)
-{
-  enum trns_result retval;
-  size_t case_nr;
-
-  struct dataset *ds = wc_data->dataset;
-  
-  /* Execute permanent transformations.  */
-  case_nr = wc_data->cases_written + 1;
-  retval = trns_chain_execute (ds->permanent_trns_chain,
-                               &wc_data->trns_case, &case_nr);
-  if (retval != TRNS_CONTINUE)
-    goto done;
-
-  /* Write case to LAG queue. */
-  if (ds->n_lag)
-    lag_case (ds, &wc_data->trns_case);
-
-  /* Write case to replacement active file. */
-  wc_data->cases_written++;
-  if (ds->proc_sink->class->write != NULL) 
-    {
-      if (ds->compactor != NULL) 
-        {
-          dict_compactor_compact (ds->compactor, &wc_data->sink_case,
-                                  &wc_data->trns_case);
-          ds->proc_sink->class->write (ds->proc_sink, &wc_data->sink_case);
-        }
-      else
-        ds->proc_sink->class->write (ds->proc_sink, &wc_data->trns_case);
-    }
-  
-  /* Execute temporary transformations. */
-  if (ds->temporary_trns_chain != NULL) 
-    {
-      retval = trns_chain_execute (ds->temporary_trns_chain,
-                                   &wc_data->trns_case,
-                                   &wc_data->cases_written);
-      if (retval != TRNS_CONTINUE)
-        goto done;
-    }
-
-  /* Pass case to procedure. */
-  if (wc_data->proc != NULL)
-    if (!wc_data->proc (&wc_data->trns_case, wc_data->aux, ds))
-      retval = TRNS_ERROR;
-
- done:
-  clear_case (ds, &wc_data->trns_case);
-  return retval != TRNS_ERROR;
-}
-
 /* Add C to the lag queue. */
 static void
 lag_case (struct dataset *ds, const struct ccase *c)
@@ -430,10 +464,6 @@ close_active_file (struct dataset *ds)
       ds->compactor = NULL;
     }
     
-  /* Free data source. */
-  free_case_source (ds->proc_source);
-  ds->proc_source = NULL;
-
   /* Old data sink becomes new data source. */
   if (ds->proc_sink->class->make_source != NULL)
     ds->proc_source = ds->proc_sink->class->make_source (ds->proc_sink);
Index: src/data/procedure.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/procedure.h,v
retrieving revision 1.8
diff -u -p -r1.8 procedure.h
--- src/data/procedure.h	16 Dec 2006 03:40:41 -0000	1.8
+++ src/data/procedure.h	17 Dec 2006 06:28:24 -0000
@@ -92,9 +92,11 @@ bool multipass_procedure_with_splits (st
 					   void *aux)
      WARN_UNUSED_RESULT;
 
-
-
 time_t time_of_last_procedure (struct dataset *ds);
+
+void proc_open (struct dataset *);
+bool proc_read (struct dataset *, struct ccase **);
+bool proc_close (struct dataset *);
 
 
 struct ccase *lagged_case (const struct dataset *ds, int n_before);
Index: src/data/storage-stream.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/storage-stream.c,v
retrieving revision 1.8
diff -u -p -r1.8 storage-stream.c
--- src/data/storage-stream.c	15 Dec 2006 00:16:02 -0000	1.8
+++ src/data/storage-stream.c	17 Dec 2006 06:28:24 -0000
@@ -31,42 +31,37 @@
 
 #include "xalloc.h"
 
-/* Information about storage sink or source. */
-struct storage_stream_info 
+/* Storage sink. */
+
+/* Information about storage sink. */
+struct storage_sink_info 
   {
     struct casefile *casefile;  /* Storage. */
   };
-
-/* Storage sink. */
+
+static struct storage_sink_info *
+get_storage_sink_info (struct case_sink *sink) 
+{
+  assert (sink->class == &storage_sink_class);
+  return sink->aux;
+}
 
 /* Initializes a storage sink. */
 static void
 storage_sink_open (struct case_sink *sink)
 {
-  struct storage_stream_info *info;
+  struct storage_sink_info *info;
 
   sink->aux = info = xmalloc (sizeof *info);
   info->casefile = fastfile_create (sink->value_cnt);
 }
 
-/* Destroys storage stream represented by INFO. */
-static void
-destroy_storage_stream_info (struct storage_stream_info *info) 
-{
-  if (info != NULL) 
-    {
-      casefile_destroy (info->casefile);
-      free (info); 
-    }
-}
-
 /* Writes case C to the storage sink SINK.
    Returns true if successful, false if an I/O error occurred. */
 static bool
 storage_sink_write (struct case_sink *sink, const struct ccase *c)
 {
-  struct storage_stream_info *info = sink->aux;
-
+  struct storage_sink_info *info = get_storage_sink_info (sink);
   return casefile_append (info->casefile, c);
 }
 
@@ -74,7 +69,9 @@ storage_sink_write (struct case_sink *si
 static void
 storage_sink_destroy (struct case_sink *sink)
 {
-  destroy_storage_stream_info (sink->aux);
+  struct storage_sink_info *info = get_storage_sink_info (sink);
+  casefile_destroy (info->casefile);
+  free (info); 
 }
 
 /* Closes the sink and returns a storage source to read back the
@@ -82,9 +79,9 @@ storage_sink_destroy (struct case_sink *
 static struct case_source *
 storage_sink_make_source (struct case_sink *sink) 
 {
-  struct case_source *source
-    = create_case_source (&storage_source_class, sink->aux);
-  sink->aux = NULL;
+  struct storage_sink_info *info = get_storage_sink_info (sink);
+  struct case_source *source = storage_source_create (info->casefile);
+  info->casefile = NULL;
   return source;
 }
 
@@ -100,65 +97,73 @@ const struct case_sink_class storage_sin
 
 /* Storage source. */
 
+struct storage_source_info 
+  {
+    struct casefile *casefile;  /* Storage. */
+    struct casereader *reader;  /* Reader. */
+  };
+
+static struct storage_source_info *
+get_storage_source_info (const struct case_source *source) 
+{
+  assert (source->class == &storage_source_class);
+  return source->aux;
+}
+
 /* Returns the number of cases that will be read by
    storage_source_read(). */
 static int
 storage_source_count (const struct case_source *source) 
 {
-  struct storage_stream_info *info = source->aux;
-
+  struct storage_source_info *info = get_storage_source_info (source);
   return casefile_get_case_cnt (info->casefile);
 }
 
-/* Reads all cases from the storage source and passes them one by one to
-   write_case(). */
+/* Reads one case into OUTPUT_CASE.
+   Returns true if successful, false at end of file or if an
+   I/O error occurred. */
 static bool
-storage_source_read (struct case_source *source,
-                     struct ccase *output_case,
-                     write_case_func *write_case, write_case_data wc_data)
+storage_source_read (struct case_source *source, struct ccase *output_case)
 {
-  struct storage_stream_info *info = source->aux;
+  struct storage_source_info *info = get_storage_source_info (source);
   struct ccase casefile_case;
-  struct casereader *reader;
-  bool ok = true;
 
-  for (reader = casefile_get_reader (info->casefile, NULL);
-       ok && casereader_read (reader, &casefile_case);
-       case_destroy (&casefile_case))
+  if (info->reader == NULL)
+    info->reader = casefile_get_reader (info->casefile, NULL);
+
+  if (casereader_read (info->reader, &casefile_case))
     {
       case_copy (output_case, 0,
                  &casefile_case, 0,
                  casefile_get_value_cnt (info->casefile));
-      ok = write_case (wc_data);
+      return true;
     }
-  casereader_destroy (reader);
-
-  return ok;
+  else
+    return false;
 }
 
-/* Destroys the source's internal data. */
-static void
+/* Destroys the source.
+   Returns true if successful read, false if an I/O occurred
+   during destruction or previously. */
+static bool
 storage_source_destroy (struct case_source *source)
 {
-  destroy_storage_stream_info (source->aux);
+  struct storage_source_info *info = get_storage_source_info (source);
+  bool ok = true;
+  if (info->casefile)
+    {
+      ok = !casefile_error (info->casefile);
+      casefile_destroy (info->casefile); 
+    }
+  free (info);
+  return ok;
 }
 
-/* Storage source. */
-const struct case_source_class storage_source_class = 
-  {
-    "storage",
-    storage_source_count,
-    storage_source_read,
-    storage_source_destroy,
-  };
-
 /* Returns the casefile encapsulated by SOURCE. */
 struct casefile *
 storage_source_get_casefile (struct case_source *source) 
 {
-  struct storage_stream_info *info = source->aux;
-
-  assert (source->class == &storage_source_class);
+  struct storage_source_info *info = get_storage_source_info (source);
   return info->casefile;
 }
 
@@ -167,25 +172,33 @@ storage_source_get_casefile (struct case
 struct casefile *
 storage_source_decapsulate (struct case_source *source) 
 {
-  struct storage_stream_info *info = source->aux;
-  struct casefile *casefile;
-
-  assert (source->class == &storage_source_class);
-  casefile = info->casefile;
+  struct storage_source_info *info = get_storage_source_info (source);
+  struct casefile *casefile = info->casefile;
+  assert (info->reader == NULL);
   info->casefile = NULL;
   free_case_source (source);
   return casefile;
 }
 
-/* Creates and returns a new storage stream that encapsulates
+/* Creates and returns a new storage source that encapsulates
    CASEFILE. */
 struct case_source *
 storage_source_create (struct casefile *casefile)
 {
-  struct storage_stream_info *info;
+  struct storage_source_info *info;
 
   info = xmalloc (sizeof *info);
   info->casefile = casefile;
+  info->reader = NULL;
 
   return create_case_source (&storage_source_class, info);
 }
+
+/* Storage source. */
+const struct case_source_class storage_source_class = 
+  {
+    "storage",
+    storage_source_count,
+    storage_source_read,
+    storage_source_destroy,
+  };
Index: src/data/transformations.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/transformations.c,v
retrieving revision 1.4
diff -u -p -r1.4 transformations.c
--- src/data/transformations.c	15 Dec 2006 00:16:02 -0000	1.4
+++ src/data/transformations.c	17 Dec 2006 06:28:24 -0000
@@ -188,13 +188,13 @@ trns_chain_next (struct trns_chain *chai
    terminate, or TRNS_CONTINUE if the transformations finished
    due to "falling off the end" of the set of transformations. */
 enum trns_result
-trns_chain_execute (struct trns_chain *chain, struct ccase *c,
-                    const size_t *case_nr) 
+trns_chain_execute (struct trns_chain *chain, enum trns_result start,
+                    struct ccase *c, const size_t *case_nr) 
 {
   size_t i;
 
   assert (chain->finalized);
-  for (i = 0; i < chain->trns_cnt; )
+  for (i = start < 0 ? 0 : start; i < chain->trns_cnt; )
     {
       struct transformation *trns = &chain->trns[i];
       int retval = trns->execute (trns->aux, c, *case_nr);
@@ -202,8 +202,8 @@ trns_chain_execute (struct trns_chain *c
         i++;
       else if (retval >= 0)
         i = retval + trns->idx_ofs;
-      else
-        return retval; 
+      else 
+        return retval == TRNS_END_CASE ? i + 1 : retval; 
     }
 
   return TRNS_CONTINUE;
Index: src/data/transformations.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/transformations.h,v
retrieving revision 1.4
diff -u -p -r1.4 transformations.h
--- src/data/transformations.h	15 Dec 2006 00:16:02 -0000	1.4
+++ src/data/transformations.h	17 Dec 2006 06:28:24 -0000
@@ -30,7 +30,7 @@ enum trns_result 
     TRNS_CONTINUE = -1,         /* Continue to next transformation. */
     TRNS_DROP_CASE = -2,        /* Drop this case. */
     TRNS_ERROR = -3,            /* A serious error, so stop the procedure. */
-    TRNS_NEXT_CASE = -4,        /* Skip to next case.  INPUT PROGRAM only. */
+    TRNS_END_CASE = -4,         /* Skip to next case.  INPUT PROGRAM only. */
     TRNS_END_FILE = -5          /* End of input.  INPUT PROGRAM only. */
   };
 
@@ -50,8 +50,8 @@ bool trns_chain_is_empty (const struct t
 void trns_chain_append (struct trns_chain *, trns_finalize_func *,
                         trns_proc_func *, trns_free_func *, void *);
 size_t trns_chain_next (struct trns_chain *);
-enum trns_result trns_chain_execute (struct trns_chain *, struct ccase *,
-                                     const size_t *case_nr);
+enum trns_result trns_chain_execute (struct trns_chain *, enum trns_result,
+                                     struct ccase *, const size_t *case_nr);
 
 void trns_chain_splice (struct trns_chain *, struct trns_chain *);
 
Index: src/language/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/ChangeLog,v
retrieving revision 1.16
diff -u -p -r1.16 ChangeLog
--- src/language/ChangeLog	3 Dec 2006 22:16:45 -0000	1.16
+++ src/language/ChangeLog	17 Dec 2006 06:28:24 -0000
@@ -1,3 +1,11 @@
+Sat Dec 16 22:15:55 2006  Ben Pfaff  <blp@gnu.org>
+
+	Make it possible to pull cases from the active file with a
+	function call, instead of requiring indirection through a callback
+	function.
+
+	* command.def: Marked MATRIX DATA as unimplemented.
+
 Sun Dec  3 11:59:10 2006  Ben Pfaff  <blp@gnu.org>
 
 	* syntax-file.c (read_syntax_file): Always read GETL_BATCH lines.
Index: src/language/command.def
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/command.def,v
retrieving revision 1.11
diff -u -p -r1.11 command.def
--- src/language/command.def	15 Dec 2006 00:16:02 -0000	1.11
+++ src/language/command.def	17 Dec 2006 06:28:24 -0000
@@ -44,7 +44,6 @@ DEF_CMD (S_INITIAL | S_DATA | S_INPUT_PR
 DEF_CMD (S_INITIAL | S_DATA, 0, "GET", cmd_get)
 DEF_CMD (S_INITIAL | S_DATA, 0, "IMPORT", cmd_import)
 DEF_CMD (S_INITIAL | S_DATA, 0, "INPUT PROGRAM", cmd_input_program)
-DEF_CMD (S_INITIAL | S_DATA, 0, "MATRIX DATA", cmd_matrix_data)
 
 /* Transformations and utilities that may appear after active
    file definition or within INPUT PROGRAM. */
@@ -188,6 +187,7 @@ UNIMPL_CMD ("LOGLINEAR", "General model 
 UNIMPL_CMD ("MANOVA", "Multivariate analysis of variance")
 UNIMPL_CMD ("MAPS", "Geographical display")
 UNIMPL_CMD ("MATRIX", "Matrix processing")
+UNIMPL_CMD ("MATRIX DATA", "Matrix data input")
 UNIMPL_CMD ("MCONVERT", "Convert covariance/correlation matrices")
 UNIMPL_CMD ("MIXED", "Mixed linear models")
 UNIMPL_CMD ("MODEL CLOSE ", "Close server connection")
Index: src/language/data-io/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/ChangeLog,v
retrieving revision 1.35
diff -u -p -r1.35 ChangeLog
--- src/language/data-io/ChangeLog	10 Dec 2006 03:42:51 -0000	1.35
+++ src/language/data-io/ChangeLog	17 Dec 2006 06:28:25 -0000
@@ -1,3 +1,36 @@
+Sat Dec 16 22:16:18 2006  Ben Pfaff  <blp@gnu.org>
+
+	Make it possible to pull cases from the active file with a
+	function call, instead of requiring indirection through a callback
+	function.
+
+	* automake.mk: Removed matrix-data.c.
+
+	* matrix-data.c: Removed.
+
+	* data-list.c (data_list_source_read): Conform with new
+	case_source_class interface.
+	(data_list_source_destroy): Ditto.
+
+	* get.c (case_reader_source_class): Ditto.
+	(case_reader_source_destroy): Ditto.
+	(parse_output_proc): Take advantage of new procedure interface.
+	(output_proc): Removed.
+	(struct mtf_file): Add "struct ccase *" member to allow use of new
+	procedure interface.
+	(cmd_match_files): Take advantage of new procedure interface.
+	(mtf_processing_finish): Removed.
+	(mtf_read_nonactive_records): Renamed mtf_read_records.  Now reads
+	from every file, without any exception for the active file.
+	(mtf_compare_BY_values): Simplify for new interface.
+	(mtf_processing): Simplify for new interface.
+
+	* inpt-pgm.c (is_valid_state): New function.
+	(input_program_source_read): Conform with new case_source_class
+	interface.
+	(input_program_source_destroy): Ditto.
+	(end_case_trns_proc): Now just needs to return TRNS_END_CASE.
+
 Sat Dec  9 18:43:34 2006  Ben Pfaff  <blp@gnu.org>
 
 	* list.q (cmd_list): Use new var_create, var_destroy functions.
Index: src/language/data-io/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/automake.mk,v
retrieving revision 1.8
diff -u -p -r1.8 automake.mk
--- src/language/data-io/automake.mk	14 Dec 2006 10:45:19 -0000	1.8
+++ src/language/data-io/automake.mk	17 Dec 2006 06:28:25 -0000
@@ -11,7 +11,6 @@ language_data_io_sources = \
 	src/language/data-io/inpt-pgm.h \
 	src/language/data-io/print.c \
 	src/language/data-io/print-space.c \
-	src/language/data-io/matrix-data.c   \
 	src/language/data-io/data-reader.c \
 	src/language/data-io/data-reader.h \
 	src/language/data-io/data-writer.c \
Index: src/language/data-io/data-list.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/data-list.c,v
retrieving revision 1.29
diff -u -p -r1.29 data-list.c
--- src/language/data-io/data-list.c	15 Dec 2006 00:16:02 -0000	1.29
+++ src/language/data-io/data-list.c	17 Dec 2006 06:28:25 -0000
@@ -806,13 +806,11 @@ data_list_trns_proc (void *dls_, struct 
   return retval;
 }
 
-/* Reads all the records from the data file and passes them to
-   write_case().
-   Returns true if successful, false if an I/O error occurred. */
+/* Reads one case into OUTPUT_CASE.
+   Returns true if successful, false at end of file or if an
+   I/O error occurred. */
 static bool
-data_list_source_read (struct case_source *source,
-                       struct ccase *c,
-                       write_case_func *write_case, write_case_data wc_data)
+data_list_source_read (struct case_source *source, struct ccase *c)
 {
   struct data_list_pgm *dls = source->aux;
 
@@ -826,26 +824,19 @@ data_list_source_read (struct case_sourc
       dls->skip_records--;
     }
   
-  for (;;) 
-    {
-      bool ok;
-
-      if (!read_from_data_list (dls, c)) 
-        return !dfm_reader_error (dls->reader);
-
-      dfm_push (dls->reader);
-      ok = write_case (wc_data);
-      dfm_pop (dls->reader);
-      if (!ok)
-        return false;
-    }
+  return read_from_data_list (dls, c);
 }
 
-/* Destroys the source's internal data. */
-static void
+/* Destroys the source.
+   Returns true if successful read, false if an I/O occurred
+   during destruction or previously. */
+static bool
 data_list_source_destroy (struct case_source *source)
 {
-  data_list_trns_free (source->aux);
+  struct data_list_pgm *dls = source->aux;
+  bool ok = !dfm_reader_error (dls->reader);
+  data_list_trns_free (dls);
+  return ok;
 }
 
 static const struct case_source_class data_list_source_class = 
